/***********************************************************************

  c35sms: Server.h
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  1.0		Initial version

***********************************************************************/


#ifndef __SERVER_H__
#define __SERVER_H__


#include <string>
#include <list>
#include <cc++/socket.h>
#include <cc++/slog.h>
#include "Main.h"


#ifdef CCXX_NAMESPACES
using namespace ost;
#endif
using namespace std;


/** Server socket class
 *
 * Listening for the incoming request
 * to send a SMS.
 *
 */
class SMSServer : public TCPSocket {
	public:
		SMSServer(const InetAddress & bind, tpport_t port, const Addresses & allowed, Slog * logger = NULL); /**< Constructor */
		
	protected:
		virtual bool onAccept(const InetHostAddress & ia, tpport_t port); /**< Connection filter */
		
	private:
		Slog * syslog;   /**< Syslog facility */
		Addresses allow; /**< Allowed client addresses */
};


#endif
